// 1. Name of module
module scoreboard;

// 2. Import asteroids to get a hold of the level number variable 
import asteroids;

// 3. Import our truetype font, point and color to pass to font draw struct, window to place font, scenegraph for the scenegraph functionality
// we also have our scoreboard object defined as a global 
import arc.font;
import arc.math.point;
import arc.draw.color;
import arc.window; 
import arc.scenegraph.all; 

import tango.text.convert.Integer;

Scoreboard scoreBoard;

// 4. Scoreboard class will hold our scoreboard
class Scoreboard
{
public:

	// 5. This function will load our font and initialize our score
	this()
	{
		Font font = new Font("astbin/font.ttf", 20);
		
		transform = new Transform(rootNode);
		transform.translation = Point(arc.window.getWidth-font.getWidth(cast(char[])"Score: 99999"), 10);
		text = new Text(transform, font, Color(0,255,0, 150));
		
		reset();
	}

	//6. add something to our score
	void addScore(int argAdd)
	{
		score += argAdd; 
		updateText();
	}	 

	//7. reset the score to zero
	void reset()
	{
		score = 0;
		updateText();
	}
	
	///8. get the score
	int getScore() { return score; }
	
private:
	//9. update text of scoreboard 
	void updateText()
	{
		text.text = "Score: " ~ .toString(score) ~ "\nLevel: " ~ .toString(asteroids.level);
	}

	//10. transform and font nodes and score
	Transform transform;
	Text text;
	int score; 
}
