//1. Module anem
module spacearea;

//2. Imports 
import 
	arc.physics.world,
	arc.physics.shapes.box,
	arc.math.routines,
	arc.types,
	asteroid,
	starfield;

//3. Define space area globally 
SpaceArea area;

//4. Space area derives from world
class SpaceArea : World
{
	//5. Initialize spacearea with walls that keep ship in playing bounds 
	this()
	{		
		super(starfield.stars, Rect(0,0,800,600), 10, Point(0,0));
		
		walls[0] = new Box(this, Size(800,10), float.max);
		walls[0].translation.set(400, 0 - 6);
		
		walls[1] = new Box(this, Size(800,10), float.max);
		walls[1].translation.set(400, 600 + 6);
		
		walls[2] = new Box(this, Size(10,600), float.max);
		walls[2].translation.set(0 - 6, 300);
		
		walls[3] = new Box(this, Size(10,600), float.max);
		walls[3].translation.set(800 + 6, 300);
	}
	
	//6. Setup asteroids depending on level number 
	void setupAsteroids(uint levelNum)
	{
		Asteroid.count = 0;
		for (int i = 0; i < levelNum + 2; ++i)
			Asteroid.createRandomAsteroid();
	}
	
private:
	//7. 4 walls that keep players in bounds 
	Box walls[4];
}